---
title: ':defined'
slug: 'Web/CSS/:defined'
tags:
  - CSS
  - Layout
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{ CSSRef }}</div>

<p>The <strong><code>:defined</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents any element that has been defined. This includes any standard element built in to the browser, and custom elements that have been successfully defined (i.e. with the {{domxref("CustomElementRegistry.define()")}} method).</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any defined element */
:defined {
  font-style: italic;
}

/* Selects any instance of a specific custom element */
simple-custom:defined {
  display: block;
}
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Hiding_elements_until_they_are_defined">Hiding elements until they are defined</h3>

<p>The following snippets are taken from our <a href="https://github.com/mdn/web-components-examples/tree/master/defined-pseudo-class">defined-pseudo-class</a> demo (<a href="https://mdn.github.io/web-components-examples/defined-pseudo-class/">see it live also</a>).</p>

<p>In this demo we define a very simple trivial custom element:</p>

<pre class="brush: js notranslate">customElements.define('simple-custom',
  class extends HTMLElement {
    constructor() {
      super();

      let divElem = document.createElement('div');
      divElem.textContent = this.getAttribute('text');

      let shadowRoot = this.attachShadow({mode: 'open'})
        .appendChild(divElem);
  }
})</pre>

<p>Then insert a copy of this element into the document, along with a standard <code>&lt;p&gt;</code>:</p>

<pre class="brush: html notranslate">&lt;simple-custom text="Custom element example text"&gt;&lt;/simple-custom&gt;

&lt;p&gt;Standard paragraph example text&lt;/p&gt;</pre>

<p>In the CSS we first include the following rules:</p>

<pre class="brush: css notranslate">// Give the two elements distinctive backgrounds
p {
  background: yellow;
}

simple-custom {
  background: cyan;
}

// Both the custom and the built-in element are given italic text
:defined {
  font-style: italic;
}</pre>

<p>Then provide the following two rules to hide any instances of our custom element that are not defined, and display instances that are defined as block level elements:</p>

<pre class="brush: css notranslate">simple-custom:not(:defined) {
  display: none;
}

simple-custom:defined {
  display: block;
}</pre>

<p>This is useful if you have a complex custom element that takes a while to load into the page — you might want to hide instances of the element until definition is complete, so that you don't end up with flashes of ugly unstyled elements on the page</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('HTML WHATWG', 'semantics-other.html#selector-defined', ':defined') }}</td>
   <td>{{ Spec2('HTML WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.selectors.defined")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Web_Components">Web components</a></li>
</ul>
